import es 
import playerlib 

es.load("myo_achievement") 
achievementManager = es.import_addon("myo_achievement") 

info = es.AddonInfo()
info.name     = "ZombieMod Achievements"
info.version  = "1.0"
info.url      = "http://addons.eventscripts.com/addons/view/zombieachievements"
info.basename = "zombieachievements"
info.author   = "Skael"

'''
******************************
Here you can make your own map achievements. They will be achieved if all zombies were killed and if you are a living human.
Here's the model:
mapAchi["whole mapname (case sensitive)"] = ("name of achievement", "description", 1)
Do NOT change anything that isn't in quotations. 
******************************
'''

#To enable map achievements, remove the "#" from the following 2 lines and set map_achievements to 1.

#mapAchi = achievementManager.AddAchievementGroup("mapGroup", "Maps Survived", "Sub-menu for maps survived.")
#mapAchi["ze_the_Mines_of_Moria_v4_1"] = ("Fly, You Fools!", "Survive the Mines of Moria.", 1) #This is an example achievement.
map_achievements = 0 #set to 1 to enable map achievements.

survAchi = achievementManager.AddAchievementGroup("survivalGroup", "Survival", "Sub-menu for survival.") 
survAchi["surv1"] = ("Boy Scout", "Win 5 rounds as a human. All zombies must've been killed.", 5) 
survAchi["surv2"] = ("Lucker", "Win 10 rounds as a human. All zombies must've been killed.", 10) 
survAchi["surv3"] = ("Tenderfeet", "Win 15 rounds as a human. All zombies must've been killed.", 15) 
survAchi["surv4"] = ("Rookie", "Win 20 rounds as a human. All zombies must've been killed.", 20) 
survAchi["surv5"] = ("Necrophobe", "Win 25 rounds as a human. All zombies must've been killed.", 25) 
survAchi["surv6"] = ("Ninja", "Win 50 rounds as a human. All zombies must've been killed.", 50) 
survAchi["surv7"] = ("Bring Your Tent", "Win 100 rounds as a human. All zombies must've been killed.", 100) 
survAchi["self"] = ("I, Me and Myself", "Be the last surviving human. All zombies must've been killed.", 1) 

incAchi = achievementManager.AddAchievementGroup("incGroup", "Incredible Feats", "Sub-menu for incredible feats.")
incAchi["pigstick1"] = ("Pigsticker", "Knife a zombie.", 1) 
incAchi["pigstick2"] = ("Daredevil", "Knife 5 zombies.", 5) 
incAchi["pigstick3"] = ("Maniac", "Knife 10 zombies.", 10) 
incAchi["pigstick4"] = ("Rambo", "Knife 25 zombies.", 25) 
incAchi["pigstick5"] = ("Terminator", "Knife 100 zombies.", 100)

incAchi["nade1"] = ("Failed Noobnade", "Nade a zombie.", 1) 
incAchi["nade2"] = ("Catch!", "Nade 5 zombies.", 5) 
incAchi["nade3"] = ("Hot Potato", "Nade 10 zombies.", 10) 
incAchi["nade4"] = ("Explosives Engineer", "Nade 25 zombies.", 25) 
incAchi["nade5"] = ("Descendant of Nobel", "Nade 100 zombies.", 100)

incAchi["safari"] = ("Samurai", "Kill 5 zombies in 1 round.", 5) 
incAchi["safari2"] = ("Spartan", "Kill 10 zombies in 1 round.", 10)
incAchi["pred"] = ("Vicious Predator", "Zombify 5 humans in 1 round.", 5)
incAchi["pred2"] = ("Deadly Shadow", "Zombify 10 humans in 1 round.", 10) 

killAchi = achievementManager.AddAchievementGroup("killGroup", "Number of Kills", "Sub-menu for number of kills.")
killAchi["hkill1"] = ("Initiate", "Kill 10 zombies.", 10) 
killAchi["hkill2"] = ("Trigger Happy", "Kill 25 zombies.", 25) 
killAchi["hkill3"] = ("Holy Vanquisher", "Kill 50 zombies.", 50) 
killAchi["hkill4"] = ("Necrophilia", "Kill 100 zombies.", 100) 
killAchi["hkill5"] = ("Space Ninja", "Kill 250 zombies.", 250) 
killAchi["hkill6"] = ("You Still Here?!", "Kill 500 zombies.", 500)
killAchi["hkill7"] = ("This Will Keep You Occupied", "Kill 1000 zombies.", 1000) 
killAchi["hkill8"] = ("You've Got Balls of Steel", "Kill 5000 zombies.", 5000)
killAchi["hkill9"] = ("OVER NINE THOUSAAAAND!!!", "Kill 10000 zombies.", 10000)

killAchi["zkill1"] = ("Headcrab Junior", "Zombify 10 humans.", 10) 
killAchi["zkill2"] = ("Moldy Corpse", "Zombify 25 humans.", 25) 
killAchi["zkill3"] = ("Boogey Man", "Zombify 50 humans.", 50) 
killAchi["zkill4"] = ("Necromancer", "Zombify 100 humans.", 100) 
killAchi["zkill5"] = ("Plaugebringer", "Zombify 250 humans.", 250) 
killAchi["zkill6"] = ("Lich King", "Zombify 500 humans.", 500)
killAchi["zkill7"] = ("Demonlord", "Zombify 1000 humans.", 1000) 
killAchi["zkill8"] = ("Armageddon", "Zombify 5000 humans.", 5000)
killAchi["zkill9"] = ("Offspring of Satan", "Zombify 10000 humans.", 10000)

#Do NOT change anything below this line.

def load(): 
    es.msg("#green", "ZombieMod Achievements loaded!") 

def player_spawn(ev):
    if not incAchi["pred"].isPlayerCompleted(ev['userid']): 
        for zm_ach in ("pred", "pred2"):
            incAchi[zm_ach].resetProgressForPlayer(ev['userid']) 
    elif not incAchi["pred2"].isPlayerCompleted(ev['userid']): 
        incAchi["pred2"].resetProgressForPlayer(ev['userid']) 
    if not incAchi["safari"].isPlayerCompleted(ev['userid']): 
        for zm_ach in ("safari", "safari2"):
            incAchi[zm_ach].resetProgressForPlayer(ev['userid'])
    elif not incAchi["safari2"].isPlayerCompleted(ev['userid']): 
        incAchi["safari2"].resetProgressForPlayer(ev['userid']) 

def player_death(ev): 
    if not incAchi["pred"].isPlayerCompleted(ev['userid']): 
        for zm_ach in ("pred", "pred2"):
            incAchi[zm_ach].resetProgressForPlayer(ev['userid']) 
    elif not incAchi["pred2"].isPlayerCompleted(ev['userid']): 
        incAchi["pred2"].resetProgressForPlayer(ev['userid']) 
    if not incAchi["safari"].isPlayerCompleted(ev['userid']): 
        for zm_ach in ("safari", "safari2"):
            incAchi[zm_ach].resetProgressForPlayer(ev['userid'])
    elif not incAchi["safari2"].isPlayerCompleted(ev['userid']): 
        incAchi["safari2"].resetProgressForPlayer(ev['userid']) 
    if ev['weapon'] == "zombie_claws_of_death": 
        for zm_ach in ("pred", "pred2"):
            incAchi[zm_ach].stepProgressForPlayer(ev['attacker']) 
        for zm_ach in ("zkill1", "zkill2", "zkill3", "zkill4", "zkill5", "zkill6", "zkill7", "zkill8", "zkill9"):
            killAchi[zm_ach].stepProgressForPlayer(ev['attacker']) 
    else: 
        for zm_ach in ("safari", "safari2"): 
            incAchi[zm_ach].stepProgressForPlayer(ev['attacker']) 
        for zm_ach in ("hkill1", "hkill2", "hkill3", "hkill4", "hkill5", "hkill6", "hkill7", "hkill8", "hkill9"): 
            killAchi[zm_ach].stepProgressForPlayer(ev['attacker']) 
        if ev['weapon'] == "knife": 
            for zm_ach in ("pigstick1", "pigstick2", "pigstick3", "pigstick4", "pigstick5"): 
                incAchi[zm_ach].stepProgressForPlayer(ev["attacker"]) 
        elif ev['weapon'] == "hegrenade":
            for zm_ach in ("nade1", "nade2", "nade3", "nade4", "nade5"): 
                incAchi[zm_ach].stepProgressForPlayer(ev["attacker"]) 

def round_end(ev):
    if ev['winner'] == '3':
        if not ev['reason'] == '5':
            for zm_ach in ("surv1", "surv2", "surv3", "surv4", "surv5", "surv6", "surv7"): 
                survAchi[zm_ach].stepProgressForList("#alive")
                if es.getlivingplayercount() == 1: 
                    survAchi["self"].stepProgressForList("#alive")
            if map_achievements == 1:
                mapAchi[es.getString('eventscripts_currentmap')].stepProgressForList("#alive")